<?php

namespace App\Entities;

use CodeIgniter\Entity\Entity;

abstract class CommonEntity extends Entity
{
    protected $datamap = [];
    protected $dates   = ['created_at', 'updated_at', 'deleted_at'];
    //사용법   : $client->created_at->format('Y-m-d') 
    //비교방법 : if ($client->created_at < new \DateTime('2024-01-01')) {
    protected $casts   = [];

    public function __construct(array|null $data = null)
    {
        parent::__construct($data);
    }

    public function getPK(): int|string|null
    {
        $field = constant("static::PK");
        return $this->attributes[$field];
    }
    public function getTitle(): string
    {
        $field = constant("static::TITLE");
        return $this->attributes[$field];
    }
    public function getStatus(): string|null
    {
        return $this->attributes['status'] ?? null;
    }
    final public function getUpdatedAt(): string|null
    {
        return $this->attributes['updated_at'];
    }
    final public function setUpdatedAt(string $value): void
    {
        $this->attributes['updated_at'] = $value;
    }
    final public function getCreatedAt(): string
    {
        return $this->attributes['created_at'];
    }
}
